# Fundamental Astrometric Catalog Tools (FACT)

A Python package for processing fundamental astrometric catalogs used in our group.

[![PyPI version](https://badge.fury.io/py/fact.svg)](https://badge.fury.io/py/fact)
[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/licenses/MIT)

## Features

- Parse and process fundamental astrometric catalogs like ICRF3.

## Modules

- **cat_parser**: Read commonly used astrometric catalogs, for example, ICRF3 catalogs.

## Installation

You can install FACT using pip from PyPI:

```bash
pip install fact
```

## Requirements

When you install FACT via pip, the necessary dependencies will be automatically installed. These include any libraries required for the core functionalities of the package.

## Usage

Here's an example of how to use the cat_parser module to read an ICRF3 catalog:
```
from fact.cat_parser import read_icrf3

icrf3_data = read_icrf3("path_to_icrf3_catalog")
print(icrf3_data)
```

More detailed examples and usage guidelines will be available in the manual, which is currently under development.

## Documentation

The manual is under development and will be available soon. We encourage users to provide feedback and suggestions to help improve the package and its documentation.

## Contributing

Contributions are welcome! If you'd like to contribute to FACT, please follow these steps:

1. Fork the repository.
2. Create a new branch for your feature or bugfix (`git checkout -b feature-name`).
3. Make your changes and commit them with a clear message (`git commit -m "Add new feature"`).
4. Push to the branch (`git push origin feature-name`).
5. Submit a pull request.

For major changes, please open an issue first to discuss what you would like to change.

## License

This project is licensed under the MIT License - see the [LICENSE](https://github.com/username/FACT/blob/main/LICENSE) file for details.

## Acknowledgements

This package was developed by our research group, and we would like to thank the [Paris Observatory Geodetic VLBI Center](https://ivsopar.obspm.fr/) for providing the VLBI products that form a crucial part of this work.

## Contact

For questions, suggestions, or support, please contact [Niu](niu.liu@nju.edu.cn).